C**********************************************************************
C
C     FEM PROGRAM FOR 2D ELASTIC ANALYSIS OF STRUCTURES- FOR
C     PLANE STRESS/PLANE STRAIN/AXISYMMETRIC PROBLEMS USING
C     LINEAR-QUADRATIC ISOPARAMETRIC ELEMENTS-DEVELOPED   
C     by Dr.P.N.GODBOLE, Formerly Professor, Indian Institute of
C     Technology, Roorkee, Prsently Emeritus Professor,VNIT,Nagpur
C     Last update Dec. 2012
C**********************************************************************
      COMMON /CONT/ NP,NE,NB,NDF,NLD,NMAT,NCORD,IPRINT,LV,NPP,
     *NCN,NGAUS,ICS,NRE,NRG,NRPRS,NSFR,NSTRS,ILD
	COMMON/GEOM/CORD(200,3),IMAT(100),NOP(800),ORT(10,6),
     *D(4,4),E1,E2,C1,C2,G2,
     *NBC(60),NFIX(60),PD(60,2),U(120),XG(6),CG(6)
      COMMON/STIF/
     1P(12),DEL(2,12),COJ(2,2),COJIN(2,2),DET,DI(2,12),DIJ(2,2),DV,
     2NOPE(12),XYE(2,12),DISE(2,12),
     3XYP(3),RP,STRN(4),STRS(4),STRSP(4),
     4ESTIFM(24,24),B(4,24),DVDB(4,24),DVD(4,4)
      COMMON /SOLV/ AK(500,100),R1(500),NEQ,IBAND
      CHARACTER TITLE*72,DAT1*20,DAT2*20,dummy*30
C
      WRITE (*,10)
      WRITE (*,*) '  Please enter name of input file'
      READ (*,15) DAT1
      WRITE (*,*) '  Please enter name of output file'
      READ (*,15) DAT2
      OPEN (UNIT=5, FILE= DAT1 )
      OPEN (UNIT=6, FILE= DAT2 , STATUS='NEW')
C
      rewind 5
      READ(5,20)NPROB
      DO 100 NPR=1,NPROB
	WRITE(6,21)NPR
      READ (5,15) TITLE
      WRITE (6,10)
      WRITE (6,15) TITLE
      READ (5,20) IPRINT,NSTRS
      WRITE (6,25) IPRINT,NSTRS
      CALL GDATA
      DO 100 ILD=1,NLD
	CALL ASSEMB
      KKK=1
      CALL SOLVE (KKK)
      KKK=2
      CALL SOLVE(KKK)
	CALL OUTPUT
  100 CONTINUE

C
   10 FORMAT(72('*')//10x,'FEM Program for 2D ELASTIC  Analysis  '/
     *    10x,  'using Linear-Quadratic Isoparametric Elements for '/
     *    10x,  'Plane Stress-Plane Strain-Axisymmetric Problems   '/
     *    10x,  'by Dr.P N GODBOLE, Formerly  Prof. of Civil Engg.'/
     *    10x,  'Indian Institute of Technology, Roorkee'/
     *    10x,  'presently Emeritus Professor,VNIT/RCOEM,Nagpur'/
     *           72('*')/)
   15 FORMAT (A)
   20 format (6I5)
   21 FORMAT(/'PROBLEM NUMBER=',I5)
   25 format (/' Print Code for More Intermediate Results :',2I5/
     *         ' IPRINT =  0 : do not print: =1 : PRINT        '/
     *         ' NSTRS= 0 : STRESS AT GAUSS PT: =1 AT NODAL PT =2 BOTH')
      CLOSE (UNIT=5)
      CLOSE (UNIT=6)
      STOP
      END
c
      SUBROUTINE GDATA
C
      character dummy*30
	COMMON /CONT/ NP,NE,NB,NDF,NLD,NMAT,NCORD,IPRINT,LV,NPP,
     *NCN,NGAUS,ICS,NRE,NRG,NRPRS,NSFR
	COMMON/GEOM/CORD(200,3),IMAT(100),NOP(800),ORT(10,6),
     *D(4,4),E1,E2,C1,C2,G2,
     *NBC(60),NFIX(60),PD(60,2),U(120),XG(6),CG(6)

      COMMON/STIF/
     1P(12),DEL(2,12),COJ(2,2),COJIN(2,2),DET,DI(2,12),DIJ(2,2),DV,
     2NOPE(12),XYE(2,12),DISE(2,12),
     3XYP(3),RP,STRN(4),STRS(4),STRSP(4),
     4ESTIFM(24,24),B(4,24),DVDB(4,24),DVD(4,4)
      
      COMMON /SOLV/ AK(500,100),R1(500),NEQ,IBAND

C
C     GEOMETRICAL DATA
C
      READ (5,110) NP,NE,NB,NLD,NMAT,NPP
      
	READ (5,110) NNP,NSFR,NGAUS
      WRITE (6,120)NP,NE,NB,NLD,NMAT,NPP,NSFR
	WRITE(6,110) NNP,NSFR,NGAUS
C
C     MATERIAL PROPERTY
C
      DO 10 L=1,NMAT
      READ (5,140) N,(ORT(N,I),I=1,6)
	TISO=ORT(N,4)
	ORT(N,6)=ORT(N,3)
	IF(TISO.NE.0.)GOTO 10
      WRITE(6,131)
      WRITE (6,150) N,(ORT(N,I),I=1,3)
	E1=ORT(N,1)
	PR=ORT(N,2)
	ORT(N,6)=ORT(N,3)
	ORT(N,2)=E1
	ORT(N,3)=E1/(2.+2.*PR)
	ORT(N,4)=PR
	ORT(N,5)=PR
   10 CONTINUE
      IF(TISO.EQ.0.) GOTO 132
	WRITE(6,130)    
      WRITE (6,150) N,(ORT(N,I),I=1,6)
  132 CONTINUE
         
C	
C     PRINT PROBLEM SIZE
C
      NCORD=2
      NDF=2
      NCN=4*NSFR
      NEQ=NP*NDF
      LV=NCN*NDF
 	ICS=3
	IF(NPP.EQ.2) ICS=4
	write(6,81)
   81 FORMAT(/'NCORD,NDF,NCN,NEQ,LV,ICS'/)
	WRITE(6,110) NCORD,NDF,NCN,NEQ,LV,ICS
           
C
C     NODAL COORDINATES
C
      DO 20 II=1,NP
      DO 20 JJ=1,NCORD
   20 CORD(II,JJ)=0
      DO 30 L=1,NNP
      READ (5,140) N,(CORD(N,M),M=1,NCORD)                  
   30 WRITE (6,140) N,(CORD(N,M),M=1,NCORD)
      

C
C     ELEMENT DATA
C
      WRITE (6,170)
      MAXDIF=0
      DO 70 L=1,NE
      READ (5,110) N,(NOPE(M),M=1,NCN),IMAT(N)
      WRITE (6,180) N,(NOPE(M),M=1,NCN),IMAT(N)
C
C     STORE NODAL CONNECTION OF ELEMENT IN VECTOR  NOP
C
      NASH=NCN*(N-1)
      DO 50 K=1,NCN
   50 NOP(NASH+K)=NOPE(K)

C
C     SEMI BAND WIDTH
C
      DO 45 I=1,NCN
      DO 45 J=1,NCN
      IDIF=IABS(NOPE(J)-NOPE(I))
      IF (MAXDIF.LT.IDIF) MAXDIF=IDIF
   45 CONTINUE
   70 CONTINUE


C     GENERATE COORDINATE DATA FOR MIDSIDE NODES FOR QUADRATIC ELEMENT

      IF(NSFR.GT.1) CALL NODEXY
      WRITE (6,160)
      DO 40 N=1,NP
   40 WRITE (6,140) N,(CORD(N,M),M=1,NCORD)
C
C     BOUNDARY NODES
C
      WRITE (6,220)
      DO 60 I=1,NB
      READ (5,230) NBC(I),NFIX(I),(PD(I,J),J=1,NDF)
   60 WRITE (6,240) NBC(I),NFIX(I),(PD(I,J),J=1,NDF)
      IC=0
      DO 80 I=1,NB
      DO 80 J=1,NDF
      IC=IC+1
   80 U(IC)=PD(I,J)

      IBAND=NDF*(MAXDIF+1)
      WRITE (6,250) IBAND
	IF(IBAND.LE.100) GOTO 85
	WRITE(6,86)
   86 FORMAT(/'PROGRAM STOPPED-BANDWIDTH EXCEEDED'/)
   85 CONTINUE
C	READ GAUSSIAN INTEGRATION DATA
	WRITE(6,105)
  105   FORMAT(1X,'GAUSSIAN INTEGRATION CONSTANTS')
	CALL GAUSSP(NGAUS,XG,CG)
	DO 41 I=1,NGAUS
	WRITE(6,5) XG(I),CG(I)
   41   CONTINUE
    
    5   FORMAT(2F15.8)
  
C
  110 FORMAT (10I5)
  120 FORMAT (' tOTAL number of nodes(NP)      .LE.200 =',I5/
     *        ' Total number of  elements(NE)  .LE.100 =',I5/
     *        ' Number of boundary nodes(NB)   .LE. 60 =',I5/
     *        ' Number of load cases(NLD)      .LT  10 =',I5/
     *        ' Number of  materials (NMAT)    .LE. 10 =',I5/
     *        ' CODE FOR TYPE OF ANALYSIS(NPP)         =',I5/
     *        '    0 : PLANE STRESS    analysis'/
     *        '    1 : PLANE STRAIN    analysis'/
     *        '    2 : AXI-SYMMETRIC   analysis'/
     *        ' CODE FOR TYPE OF ELEMENT(NSFR)         =',I5/
     *        '    1 : LINEAR ISOPARAMETRIC ELEMENT   '/
     *        '    2 : QUADRATIC ISOPARAMETRIC ELEMENT'/ )    
    
  130 FORMAT(/' MATE No   E1      E2      G     PR1     PR2    THICK '/)
  131 FORMAT(/' MATE No   MOD OF ELAS    POISSOR RATIO      THICK '/)    
  140 FORMAT (I10,6F10.3)
  150 FORMAT (I5,6E12.5)
  160 FORMAT (/'  NODE    X-CORD    Y-CORD    Z-CORD '/)
  170 FORMAT (/'ELE  CONN(4=LINEAR:8=QUADRATIC)   MATERIAL TYPE'/)
  180 FORMAT (10I5)
  190 FORMAT (8F10.0)
  220 FORMAT (/' NODE   BOUNDARY           SPECIFIED DISPLACEMENT'/
     *         '  no    condition      x-            y-           z-'/)
  230 FORMAT (2I5,3F10.5)
  240 FORMAT (I5,5X,I5,3F12.3)
  250 FORMAT (/'SEMIBAND WIDTH IS EQUAL TO ',I5)
      RETURN
      END


      SUBROUTINE NODEXY
C
      character dummy*30
	COMMON /CONT/ NP,NE,NB,NDF,NLD,NMAT,NCORD,IPRINT,LV,NPP,
     *NCN,NGAUS,ICS,NRE,NRG,NRPRS,NSFR
	COMMON/GEOM/CORD(200,3),IMAT(100),NOP(800),ORT(10,6),
     *D(4,4),E1,E2,C1,C2,G2,
     *NBC(60),NFIX(60),PD(60,2),U(120),XG(6),CG(6)

      COMMON/STIF/
     1P(12),DEL(2,12),COJ(2,2),COJIN(2,2),DET,DI(2,12),DIJ(2,2),DV,
     2NOPE(12),XYE(2,12),DISE(2,12),
     3XYP(3),RP,STRN(4),STRS(4),STRSP(4),
     4ESTIFM(24,24),B(4,24),DVDB(4,24),DVD(4,4)
      


      ANSFR=NSFR
        NQ=NSFR-1 
        DO 6 N=1,NE 
        NASH=NCN*(N-1) 
        DO 6 NLV=1,NCN,NSFR
	NV1=NOP(NASH+NLV)
	NL1=NLV+NSFR
	IF(NL1.GT.NCN) NL1=1
	NV2=NOP(NASH+NL1)
	DO 4 I=1,NQ
	M=NLV+I
	J=NOP(NASH+M)
	GISH=I
	GOSH=ANSFR-GISH
	SUM=ABS(CORD(J,1))+ABS(CORD(J,2))
	IF(SUM.GT.0) GO TO 2
	K=1
   20   CORD(J,K)=(GOSH*CORD(NV1,K)+CORD(NV2,K)*GISH)/ANSFR
	K=K+1
	IF(K.EQ.2)GO TO 20
	IF(NCORD-K)4,2,4
    2   K=3
	IF(CORD(J,3).EQ.0.)GO TO 20
    4   CONTINUE 
    6   CONTINUE
	RETURN
	END
C       ****************************************************************



      SUBROUTINE ASSEMB
C
      DIMENSION LP(16)
	COMMON /CONT/ NP,NE,NB,NDF,NLD,NMAT,NCORD,IPRINT,LV,NPP,
     *NCN,NGAUS,ICS,NRE,NRG,NRPRS,NSFR
	COMMON/GEOM/CORD(200,3),IMAT(100),NOP(800),ORT(10,6),
     *D(4,4),E1,E2,C1,C2,G2,
     *NBC(60),NFIX(60),PD(60,2),U(120),XG(6),CG(6)
      COMMON/STIF/
     1P(12),DEL(2,12),COJ(2,2),COJIN(2,2),DET,DI(2,12),DIJ(2,2),DV,
     2NOPE(12),XYE(2,12),DISE(2,12),
     3XYP(3),RP,STRN(4),STRS(4),STRSP(4),
     4ESTIFM(24,24),B(4,24),DVDB(4,24),DVD(4,4)
      
      COMMON /SOLV/ AK(500,100),R1(500),NEQ,IBAND

           
C     INITIALIZE LOAD VECTOR AND GLOBAL STIFFNESS MATRIX
C
      DO 5 I=1,NEQ
    5 R1(I)=0.
      DO 10 I=1,NEQ
      DO 10 J=1,IBAND
   10 AK(I,J)=0.
C
C     ASSEMBLE STIFFNESS MATRIX
C
      DO 20 L=1,NE
      LNEW=L
      CALL STIFM(LNEW) 
C
C     LOCATION VECTOR LP
C
      JJ=0
      DO 40 I=1,NCN
      IJ=NDF*NOPE(I)-NDF
      DO 40 J=1,NDF
      JJ=JJ+1
   40 LP(JJ)=IJ+J
      IF(IPRINT.EQ.0) GOTO 708
      WRITE(6,703)
  703 FORMAT(/' DESTINATION VECTOR LP'/)
      WRITE(6,701) (LP(J),J=1,LV)
  708 CONTINUE
C
C     TRANSFER ELEMENT MATRIX TO GLOBAL MATRIX
C
      DO 50 LL=1,LV
      I=LP(LL)
      DO 50 MM=1,LV
      J=LP(MM)-I+1
      IF(J.LE.0) GO TO 50
      AK(I,J)=AK(I,J)+ESTIFM(LL,MM)
   50 CONTINUE
   20 CONTINUE

      IF(IPRINT.EQ.0) GOTO 705
      WRITE(6,704)
  704 FORMAT(/' ASSEBLED GLOBAL BANDED MATRIX'/)
      WRITE(6,702) ((AK(I,J),J=1,IBAND),I=1,NEQ)
  701 FORMAT(10I5)
  702 FORMAT(8E12.5)
  705 CONTINUE 
C
C     ASSEMBLE LOAD VECTOR IN THE ARRAY R1
C
      CALL LDATA
C
C     APPLY  BOUNDARY CONDITION TO AK
C
      DO 30 NZ=1,NB
      L=NBC(NZ)
      JZ=NFIX(NZ)
      IZ=10**(NDF-1)
      DO 60 I=1,NDF
      ID=I+NDF*(NZ-1)
      IC=I+NDF*(L-1)
      IF (JZ.EQ.0) GO TO 60
      IF (JZ.LT.IZ) GO TO 35
      CALL GEOMBC (U(ID),IC)
      JZ=JZ-IZ
   35 IZ=IZ/10
   60 CONTINUE
   30 CONTINUE
C
      RETURN
      END


      SUBROUTINE LDATA
C
      DIMENSION R(3),NOPL(4),PR(4,2),PQ(2),DJ(2),DENS(10)
      COMMON /CONT/ NP,NE,NB,NDF,NLD,NMAT,NCORD,IPRINT,LV,NPP,
     *NCN,NGAUS,ICS,NRE,NRG,NRPRS,NSFR,NSTRS,ILD
	COMMON/GEOM/CORD(200,3),IMAT(100),NOP(800),ORT(10,6),
     *D(4,4),E1,E2,C1,C2,G2,
     *NBC(60),NFIX(60),PD(60,2),U(120),XG(6),CG(6)
      COMMON/STIF/
     1P(12),DEL(2,12),COJ(2,2),COJIN(2,2),DET,DI(2,12),DIJ(2,2),DV,
     2NOPE(12),XYE(2,12),DISE(2,12),
     3XYP(3),RP,STRN(4),STRS(4),STRSP(4),
     4ESTIFM(24,24),B(4,24),DVDB(4,24),DVD(4,4)
      
      COMMON /SOLV/ AK(500,100),R1(500),NEQ,IBAND
      CHARACTER TITLE*72      
C     APPLIED NODAL LOADS
C
      DO 10 J=1,NEQ
   10 R1(J)=0.
      READ(5,7)TITLE
	READ(5,8)NRE,NRG,NRPRS
	WRITE(6,100)TITLE,ILD   
	WRITE(6,8)NRE,NRG,NRPRS
	
	DO 220 I=1,ICS
	DO 220 J=1,LV
  220   B(I,J)=0.
      IF(NRE.EQ.0)GOTO 200
C
      WRITE (6,110)
   40 CONTINUE 
      READ (5,120) NQ,(R(K),K=1,NDF)
      WRITE (6,120)  NQ,(R(K),K=1,NDF)
      DO 50 K=1,NDF
      IC=(NQ-1)*NDF+K
      R1(IC)=R(K)
   50 CONTINUE
      IF (NQ.LT.NP) GO TO 40

  200 IF((NRG).EQ.0) GO TO 400
	WRITE(6,5)
	
	READ(5,2)(DENS(I),I=1,NMAT)
	WRITE(6,2)(DENS(I),I=1,NMAT)	
       	
	DO 420 M=1,NE
	L=IMAT(M)
      THICK=ORT(L,6)
	IF(L.GT.NMAT)L=L-100
	DENSE=DENS(L)
	PQ(1)=0.
	PQ(2)=-DENSE
	GUSH=0.
	IF(DENSE.EQ.0.)GO TO 420
	
	WRITE(6,4)M,L,PQ(1),PQ(2)
  430   NASH=NCN*(M-1)
	DO 440 K=1,NCN
	MASH=NOP(NASH+K)
	DO 450 I=1,NCORD
  450   XYE(I,K)=CORD(MASH,I)
  440   NOPE(K)=MASH
	DO 460 IGAUS=1,NGAUS
	DO 460 JGAUS=1,NGAUS
	G=XG(IGAUS)
	H=XG(JGAUS)
	CALL SFR(G,H)
	CALL AUX(M)
	DV=DET*CG(IGAUS)*CG(JGAUS)
	IF(NPP.EQ.2)DV=DV*RP*6.28318530718
	IF(NCORD.EQ.3)DV=DV*XYP(3)
	IF(THICK.NE.0.)DV=DV*THICK
	PQ(1)=PQ(1)+DENSE*GUSH*XYP(1)
	DO 470 I=1,NCN
	IC=(NOPE(I)-1)*2
	DO 470 K=1,2
	IC=IC+1
  470   R1(IC)=R1(IC)+PQ(K)*P(I)*DV
  460   CONTINUE
  420   CONTINUE
  400   CONTINUE
	IF(NRPRS.EQ.0)GO TO 700
	READ(5,8)LNE
	WRITE(6,8)LNE
	NLN=NSFR+1
	DO 360 LNEW=1,LNE
	READ(5,8)(NOPL(J),J=1,NLN)
	WRITE(6,8)(NOPL(J),J=1,NLN)
	READ(5,11)((PR(I,J),I=1,NLN),J=1,NDF)
	WRITE(6,11)((PR(I,J),I=1,NLN),J=1,NDF)
	IF(PR(3,1).NE.0.)GO TO 301
	PRT=PR(2,1)
	DO 310 I=1,NLN
	PR(I,1)=PR(1,1)
  310   PR(I,2)=PRT
  301   WRITE(6,11)((PR(I,J),I=1,NLN),J=1,NDF)
	H=-1
	DO 320 J=1,NLN
	MASH=NOPL(J)
	DO 320 K=1,NCORD
	XYE(K,J)=CORD(MASH,K)
  320   CONTINUE
	DO 330 IGAUS=1,NGAUS
	G=XG(IGAUS)
	CALL SFR(G,H)
	DO 340 I=1,NCORD
	GASH=0.
	GOSH=0.
	GISH=0.
	DO 350 K=1,NLN
	GASH=GASH+XYE(I,K)*P(K)
	IF(I.GT.2)GO TO 350
	GOSH=GOSH+PR(K,I)*P(K)
	GISH=GISH+XYE(I,K)*DEL(1,K)
  350   CONTINUE
	XYP(I)=GASH
	IF(I.GT.2)GO TO 340
	PQ(I)=GOSH
	DJ(I)=GISH
  340   CONTINUE
	DV=CG(IGAUS)
	IF(NCORD.EQ.3)DV=DV*XYP(3)
	IF(NPP.EQ.2)DV=6.2831853072*DV*XYP(1)	
	DV1=DV*DJ(1)
	DV2=DV*DJ(2)
	AY=DV1*PQ(1)+DV2*PQ(2)
	AX=DV1*PQ(2)-DV2*PQ(1)
        DO 330 I=1,NLN
	NASH=2*NOPL(I)
	MASH=NASH-1
	R1(MASH)=R1(MASH)+P(I)*AX
	R1(NASH)=R1(NASH)+P(I)*AY
  330   CONTINUE
  360   CONTINUE
  700   CONTINUE
c
      I=1
   60 IF (R1(I).EQ.0) GO TO 70
      K=(10*I/NDF+9)/10
      J=(K-1)*NDF+1
      JND=J+NDF-1
      WRITE (6,120) K,(R1(I),I=J,JND)
      I=JND
   70 CONTINUE
      I=I+1
      IF (I.LE.NEQ) GO TO 60
   80 CONTINUE

    2   FORMAT(8F10.3)
    3   FORMAT(7X,'ANGLE=',F7.2,' GRAVITY CONSTANT=',F8.3,'ANGULAR 
     1  VELOCITY=',F10.4)
    4   FORMAT(2I10,2F15.5)
    5   FORMAT(1X,'DENSITY CONSTANTS FOR VARIOUS ELEMENTS')
    7   FORMAT(A)
    8   FORMAT(8I5)
    9   FORMAT(I10,3F10.3)
   11   FORMAT(8F10.3)
  100   FORMAT((A),/15X,'LOAD CASE=',I3,I5)
  108   FORMAT(1X,'LOADS FROM CARDS')
C  120   FORMAT(1X,'TOTAL NON-ZERO LOADS')
	
C
  110 FORMAT (/' Node             Load'/
     *         '  no        x-     y-     z- '/)
  120 FORMAT (I5,3F10.3)
  130 FORMAT (8F10.3)
  160 FORMAT (/' ADDITIONAL NON ZERO LOAD IN LOAD STEP = ',I5/)
      RETURN
      END


      SUBROUTINE STIFM(LNEW)
	
	COMMON /CONT/ NP,NE,NB,NDF,NLD,NMAT,NCORD,IPRINT,LV,NPP,
     *NCN,NGAUS,ICS,NRE,NRG,NRPRS,NSFR
	COMMON/GEOM/CORD(200,3),IMAT(100),NOP(800),ORT(10,6),
     *D(4,4),E1,E2,C1,C2,G2,
     *NBC(60),NFIX(60),PD(60,2),U(120),XG(6),CG(6)
      COMMON/STIF/
     1P(12),DEL(2,12),COJ(2,2),COJIN(2,2),DET,DI(2,12),DIJ(2,2),DV,
     2NOPE(12),XYE(2,12),DISE(2,12),
     3XYP(3),RP,STRN(4),STRS(4),STRSP(4),
     4ESTIFM(24,24),B(4,24),DVDB(4,24),DVD(4,4)
      
      COMMON /SOLV/ AK(500,100),R1(500),NEQ,IBAND
 	
C	FORMATION OF STIFFNESS AND CALCULATION OF BODY FORCES

	L = IMAT(LNEW)

	NASH = NCN*(LNEW-1)
	DO 200 K = 1,NCN   
	MASH = NOP(NASH+K)
	DO 300 I = 1,NCORD
   	XYE(I,K)=CORD(MASH,I)
  300	CONTINUE
	NOPE(K)=MASH
  200	CONTINUE

      CALL MOD(L)
      THICK = ORT(L,6)

      IF(IPRINT.EQ.0) GOTO 708
      WRITE(6,703)
  703 FORMAT(/' ELEMENT CONNECTIVITY MATERIAL'/)
	WRITE (6,701)LNEW,(NOPE(K),K=1,NCN),L
      
      WRITE(6,704)
  704 FORMAT(/' NODAL COORDINATE '/)
	WRITE (6,702)((XYE(I,K),K=1,NCN),I=1,NCORD)
  701 FORMAT(16I5)
  702 FORMAT(8E14.6)
      WRITE(6,707)
  707 FORMAT(/' E1   E2   C1   C2   G2   THIC '/)
      WRITE(6,702)(ORT(1,J),J=1,6) 	
      WRITE(6,705)
  705 FORMAT(/' ELASTICITY MATRIX D '/)
	WRITE (6,702)((D(I,J),J=1,ICS),I=1,ICS)
  708 CONTINUE
	
C	PUT INITIAL VALUES AS ZEROES
	DO 2 I = 1,LV
	DO 2 J = 1,LV
	ESTIFM(I,J) = 0
	IF(I.LE.4) B(I,J)=0
    2	CONTINUE
C       FORMULATION OF STIFFNESS MATRIX
	DO 100 IGAUS = 1,NGAUS
	DO 100 JGAUS = 1,NGAUS
        G = XG(IGAUS)
	H = XG(JGAUS)
	CALL SFR(G,H)
	CALL AUX(LNEW)
	DV = DET*CG(IGAUS)*CG(JGAUS)
	IF(NPP.EQ.2)DV = DV*RP*6.283185307179586
	IF(THICK.NE.0.)DV = DV *THICK
	CALL FEM
	DO 20 I = 1,LV
	DO 20 J = I,LV
	GASH = ESTIFM(I,J)
	DO 18 K = 1,ICS
	GASH = GASH + B(K,I)*DVDB(K,J)
   18	CONTINUE
	ESTIFM(I,J)=GASH
	ESTIFM(J,I)=GASH
   20	CONTINUE
  100	CONTINUE
C	IF(IMAT(LNEW).GT.NMAT)CALL ROSB

      IF(IPRINT.EQ.0) GOTO 709
      WRITE(6,706)
  706 FORMAT(/' ELEMENT STIFFNESS MATRIX'/)
	
	WRITE (6,702)((ESTIFM(I,J),J=1,LV),I=1,LV)
  709 CONTINUE
  400 CONTINUE
	
C   850   FORMAT(16I5) 
	
	RETURN
	END
C*************************************************************************


	SUBROUTINE FEM
C
      COMMON /CONT/ NP,NE,NB,NDF,NLD,NMAT,NCORD,IPRINT,LV,NPP,
     *NCN,NGAUS,ICS,NRE,NRG,NRPRS,NSFR
	COMMON/GEOM/CORD(200,3),IMAT(100),NOP(800),ORT(10,6),
     *D(4,4),E1,E2,C1,C2,G2,
     *NBC(60),NFIX(60),PD(60,2),U(120),XG(6),CG(6)
      COMMON/STIF/
     1P(12),DEL(2,12),COJ(2,2),COJIN(2,2),DET,DI(2,12),DIJ(2,2),DV,
     2NOPE(12),XYE(2,12),DISE(2,12),
     3XYP(3),RP,STRN(4),STRS(4),STRSP(4),
     4ESTIFM(24,24),B(4,24),DVDB(4,24),DVD(4,4)
      
	
C	CALCULATE B MATRIX FROM DI MATRIX
	NASH = 0
	DO 10 I = 1,NCN
	MASH = NASH + 1
	NASH = MASH + 1
	B(1,MASH) = DI(1,I)
	B(2,NASH) = DI(2,I)
	B(3,MASH) = DI(2,I)
	B(3,NASH) = DI(1,I)
	IF(NPP.EQ.2)B(4,MASH)=P(I)/RP
   10	CONTINUE
C	CALCULATE DVD MATRIX
	DO 12 I = 1,ICS
	DO 12 J = 1,ICS
	DVD(I,J)=DV*D(I,J)
   12	CONTINUE
	DO 16 I = 1,ICS
	DO 16 J = 1,LV 
	GASH = 0.
	DO 14 K = 1,ICS
	GASH =GASH + DVD(I,K)*B(K,J)
   14	CONTINUE
	DVDB(I,J) = GASH
   16	CONTINUE
	RETURN
	END
C      *******************************************************************


	SUBROUTINE AUX(LNEW)

C
      COMMON /CONT/ NP,NE,NB,NDF,NLD,NMAT,NCORD,IPRINT,LV,NPP,
     *NCN,NGAUS,ICS,NRE,NRG,NRPRS,NSFR
	COMMON/GEOM/CORD(200,3),IMAT(100),NOP(800),ORT(10,6),
     *D(4,4),E1,E2,C1,C2,G2,
     *NBC(60),NFIX(60),PD(60,2),U(120),XG(6),CG(6)
      COMMON/STIF/
     1P(12),DEL(2,12),COJ(2,2),COJIN(2,2),DET,DI(2,12),DIJ(2,2),DV,
     2NOPE(12),XYE(2,12),DISE(2,12),
     3XYP(3),RP,STRN(4),STRS(4),STRSP(4),
     4ESTIFM(24,24),B(4,24),DVDB(4,24),DVD(4,4)
      
	
C	CREATE COORDINATE JACOBIAN MATRIX 0 INTERPOLATE X,Y0COJ%I<,XY%2<
C	ARE COORDINATE OF THE JACOBIAN MATRIX,X COORDINATE & Y COORDINATE
	DO 8 I=1,2
	DO 8 J=1,2
	GASH = 0.
	DO 4 K =1,NCN
	GASH = GASH +XYE(I,K)*DEL(J,K)
    4	CONTINUE
	COJ(I,J) = GASH
    8	CONTINUE
	DO 16 I = 1,NCORD
	GASH = 0.
	DO 6 K = 1,NCN
	GASH = GASH +XYE(I,K)*P(K)
    6	CONTINUE
	XYP(I) = GASH
   16	CONTINUE
	RP = XYP(1)
C	CALCULATE DETERMINANT AND INVERSE OF COORDINATE JACOBIAN
C	DET AND COJIN(I,J) ARE DETERMINANT AND INVERSE COORDINATE JACOBIAN
	DET = COJ(1,1)*COJ(2,2) - COJ(1,2)*COJ(2,1)
	IF(DET)100,200,300
  100	CONTINUE
	WRITE(6,101)LNEW,DET
  101	FORMAT(1X,'NEGATIVE DET STOPPED AT ,ELEMENT NO =' ,I3,E12.5)
	STOP
  200	DET = .000001
  300	CONTINUE
	COJIN(1,1)=COJ(2,2)/DET
	COJIN(2,2)=COJ(1,1)/DET
	COJIN(1,2)=-COJ(1,2)/DET
	COJIN(2,1)=-COJ(2,1)/DET
C	CALCULATE CARTESIAN DERIVATIVES OF SHAPE FUNCTIONS,DI%IK<,I#X,Y
	DO 14 I = 1,2
	DO 12 K = 1,NCN
	GASH = 0.
	DO 10 J = 1,2
	GASH = GASH +DEL(J,K)*COJIN(J,I)
   10	CONTINUE
	DI(I,K) = GASH
   12	CONTINUE
   14	CONTINUE
	RETURN
	END


      SUBROUTINE MOD(L)

C
      COMMON /CONT/ NP,NE,NB,NDF,NLD,NMAT,NCORD,IPRINT,LV,NPP,
     *NCN,NGAUS,ICS,NRE,NRG,NRPRS,NSFR
	COMMON/GEOM/CORD(200,3),IMAT(100),NOP(800),ORT(10,6),
     *D(4,4),E1,E2,C1,C2,G2,
     *NBC(60),NFIX(60),PD(60,2),U(120),XG(6),CG(6)
      COMMON/STIF/
     1P(12),DEL(2,12),COJ(2,2),COJIN(2,2),DET,DI(2,12),DIJ(2,2),DV,
     2NOPE(12),XYE(2,12),DISE(2,12),
     3XYP(3),RP,STRN(4),STRS(4),STRSP(4),
     4ESTIFM(24,24),B(4,24),DVDB(4,24),DVD(4,4)
C       
      
      E1=ORT(L,1)
	E2=ORT(L,2)
	G2=ORT(L,3)
	C1=ORT(L,4)
	C2=ORT(L,5)
	CN=E1/E2
	CQ=CN*C2*C2
	D(3,3)=G2
	D(1,3)=0.
	D(3,1)=0.
	D(2,3)=0.
	D(3,2)=0.
	IF(NPP.NE.1)GO TO 20
C	D MATRIX FOR PLANE STRESS CASE
	CD=E2/(1.-CQ)
	D(1,1)=CD*CN
 	D(2,2)=CD
	D(1,2)=CD*CN*C2
	D(2,1)=CD*CN*C2
	GO TO 24
   20	CONTINUE
C	DMATRIX FOR PLANE STRAIN CASE
	CD=E2/((1.+C1)*(1.-C1-2.*CQ))
	D(1,1)=CD*CN*(1.-CQ)
	D(2,2)=CD*(1.-C1*C1)
	D(1,2)=CD*CN*(1.+C1)*C2
	D(2,1)=CD*CN*(1.+C1)*C2
	IF(NPP.NE.2)GO TO 24
C	D MATRIX FOR AXISYMMETRIC CASE
	D(4,4)=D(1,1)
	D(4,1)=CD*(C1+CQ)
	D(1,4)=CD*(C1+CQ)
	D(4,2)=D(1,2)
	D(2,4)=D(1,2)
	D(3,4)=0.
	D(4,3)=0.
   24	CONTINUE
    
	RETURN
	END
C       ******************************************************************

	SUBROUTINE SFR(G,H)
      
	COMMON /CONT/ NP,NE,NB,NDF,NLD,NMAT,NCORD,IPRINT,LV,NPP,
     *NCN,NGAUS,ICS,NRE,NRG,NRPRS,NSFR
	COMMON/GEOM/CORD(200,3),IMAT(100),NOP(800),ORT(10,6),
     *NBC(60),NFIX(60),PD(60,2),U(120),XG(6),CG(6)
      COMMON/STIF/
     1P(12),DEL(2,12),COJ(2,2),COJIN(2,2),DET,DI(2,12),DIJ(2,2),DV,
     2NOPE(12),XYE(2,12),DISE(2,12),
     3XYP(3),RP,STRN(4),STRS(4),STRSP(4),
     4ESTIFM(24,24),B(4,24),DVDB(4,24),DVD(4,4)
      

C	G AND H DENOTE THE XI AND ETA VALUE AT THE POINT CONSIDERED
	GG=G*G
	GH=G*H
	HH=H*H
	GGH=GG*H
	GHH=G*HH
	IF(NSFR-2)1,9,10
C*****	LINEAR SHAPE FUNCTION AND THEIR FIRST DERIVATIVES FOR
C*****	FOUR NODED ARBITARY QUADILATERAL
    1	P(1)=(1.-G-H+GH)/4.
	P(2)=(1.+G-H-GH)/4.
	P(3)=(1.+G+H+GH)/4.
	P(4)=(1.-G+H-GH)/4.
	DEL(1,1)=(-1.+H)/4.
	DEL(1,2)=-DEL(1,1)
	DEL(1,3)=(1.+H)/4.
	DEL(1,4)=-DEL(1,3)
	DEL(2,1)=(-1.+G)/4.
	DEL(2,2)=(-1.-G)/4.
	DEL(2,3)=-DEL(2,2)
	DEL(2,4)=-DEL(2,1)
	RETURN
C	PARABOLIC SHAPE FUNCTION AND THEIR FIRST DERIVATIVES FOR
C	CURVED 8-NODED ARBITARY QUADILATERAL
    9	G2=G*2.
	H2=H*2.
	GH2=GH*2.
	P(1)=(-1.+GH+GG+HH-GGH-GHH)/4.
	P(2)=(1.-H-GG+GGH)/2.
	P(3)=(-1.-GH+GG+HH-GGH+GHH)/4.
	P(4)=(1.+G-HH-GHH)/2.
	P(5)=(-1.+GH+GG+HH+GGH+GHH)/4.
	P(6)=(1.+H-GG-GGH)/2.
	P(7)=(-1.-GH+GG+HH+GGH-GHH)/4.
  	P(8)=(1.-G-HH+GHH)/2.
 	DEL(1,1)=(H+G2-GH2-HH)/4.
	DEL(1,2)=-G+GH
	DEL(1,3)=(-H+G2-GH2+HH)/4.
	DEL(1,4)=(1.-HH)/2.
	DEL(1,5)=(H+G2+GH2+HH)/4.
	DEL(1,6)=-G-GH
	DEL(1,7)=(-H+G2+GH2-HH)/4.
	DEL(1,8)=(-1.+HH)/2.
	DEL(2,1)=(G+H2-GG-GH2)/4.
	DEL(2,2)=(-1.+GG)/2.
	DEL(2,3)=(-G+H2-GG+GH2)/4.
	DEL(2,4)=-H-GH
	DEL(2,5)=(G+H2+GG+GH2)/4.
	DEL(2,6)=(1.-GG)/2.
	DEL(2,7)=(-G+H2+GG-GH2)/4.
	DEL(2,8)=-H+GH
   10 CONTINUE
	RETURN
	END
   

      SUBROUTINE GAUSSP(M,X,W) 
	DIMENSION X(6),W(6)
	GO TO (1,2,3),M
    1   X(1)=0.
	W(1)=1.
	RETURN
    2   X(1)=-0.577350269189626
	W(1)=1.
	GO TO 100
    3   X(1)=-0.774596669241483
	X(2)=0.
	W(1)=0.555555555555556
	W(2)=0.888888888888889
	
  100   N=M/2
        DO 200 J=1,N
	NASH=M+1-J
	X(NASH)=-X(J)
        W(NASH)=W(J)
  200   CONTINUE
	RETURN
	END

      SUBROUTINE GEOMBC (U,N)
C
      
      COMMON /SOLV/ AK(500,100),R1(500),NEQ,IBAND
C
C     IT MODIFIES THE ASSEMBLED STIFFNESS AND LOADS FOR
C     PRESCRIBED DISPLACEMENTS   U AT N th DEGREE OF FREEDOM
C
      DO 100 M=2,IBAND
      K=N-M+1
      IF(K.LE.0) GO TO 50
      R1(K)=R1(K)-AK(K,M)*U
      AK(K,M)=0.0
   50 K=N+M-1
      IF(K.GT.NEQ) GO TO 100
      R1(K)=R1(K)-AK(N,M)*U
      AK(N,M)=0.0
  100 CONTINUE
      AK(N,1)=1.0
      R1(N)=U
      RETURN
      END

      SUBROUTINE SOLVE (KKK)
C
      
      COMMON /SOLV/ AK(500,100),R1(500),NEQ,IBAND
C
C     KKK=1 TRIANGULARIZES THE SYMMETRIC BAND MATRIX AK
C     KKK=2 SOLVER FOR RIGHT HAND SIDE R, SOLUTION RETURNS IN R
C
      NRS=NEQ-1
      NR=NEQ
      IF (KKK.EQ.2) GO TO 200
      DO 120 N=1,NRS
      M=N-1
      MR=AMIN0(IBAND,NR-M)
      PIVOT=AK(N,1)
      DO 120 L=2,MR
      CP=AK(N,L)/PIVOT
      I=M+L
      J=0
      DO 110 K=L,MR
      J=J+1
  110 AK(I,J)=AK(I,J)-CP*AK(N,K)
  120 AK(N,L)=CP
      GO TO 400
  200 DO 220 N=1,NRS
      M=N-1
      MR=AMIN0(IBAND,NR-M)
      CP=R1(N)
      R1(N)=CP/AK(N,1)
      DO 220 L=2,MR
      I=M+L
  220 R1(I)=R1(I)-AK(N,L)*CP
      R1(NR)=R1(NR)/AK(NR,1)
      DO 320 I=1,NRS
      N=NR-I
      M=N-1
      MR=AMIN0(IBAND,NR-M)
      DO 320 K=2,MR
      L=M+K
C
C     STORE DISPLACEMENTS IN LOAD VECTOR R

  320 R1(N)=R1(N)-AK(N,K)*R1(L)
  400 RETURN
      END


      SUBROUTINE OUTPUT
      COMMON /CONT/ NP,NE,NB,NDF,NLD,NMAT,NCORD,IPRINT,LV,NPP,
     *NCN,NGAUS,ICS,NRE,NRG,NRPRS,NSFR
	COMMON/GEOM/CORD(200,3),IMAT(100),NOP(800),ORT(10,6),
     *NBC(60),NFIX(60),PD(60,2),U(120),XG(6),CG(6)
      COMMON/STIF/
     1P(12),DEL(2,12),COJ(2,2),COJIN(2,2),DET,DI(2,12),DIJ(2,2),DV,
     2NOPE(12),XYE(2,12),DISE(2,12),
     3XYP(3),RP,STRN(4),STRS(4),STRSP(4),
     4ESTIFM(24,24),B(4,24),DVDB(4,24),DVD(4,4)
      
      COMMON /SOLV/ AK(500,100),R1(500),NEQ,IBAND

      WRITE(6,110)
      DO 660 I=1,NP
      II=NDF*(I-1)+1
      JJ=II+NDF-1 
      WRITE(6,111)I,(R1(N),N=II,JJ)
  660 CONTINUE
  110 FORMAT(1X,' DISPLACEMENTS')
  111 FORMAT(I10,6E20.6)
      CALL STRESS 
      RETURN
      END
      

	SUBROUTINE STRESS


      COMMON /CONT/ NP,NE,NB,NDF,NLD,NMAT,NCORD,IPRINT,LV,NPP,
     *NCN,NGAUS,ICS,NRE,NRG,NRPRS,NSFR,NSTRS
	COMMON/GEOM/CORD(200,3),IMAT(100),NOP(800),ORT(10,6),
     *D(4,4),E1,E2,C1,C2,G2,
     *NBC(60),NFIX(60),PD(60,2),U(120),XG(6),CG(6)
      COMMON/STIF/
     1P(12),DEL(2,12),COJ(2,2),COJIN(2,2),DET,DI(2,12),DIJ(2,2),DV,
     2NOPE(12),XYE(2,12),DISE(2,12),
     3XYP(3),RP,STRN(4),STRS(4),STRSP(4),
     4ESTIFM(24,24),B(4,24),DVDB(4,24),DVD(4,4)
      
      COMMON /SOLV/ AK(500,100),R1(500),NEQ,IBAND
	DIMENSION DIS(2,200)
	
	DO 700 I=1,NP
	II=NDF*(I-1)+1
	JJ=II+NDF-1
	DIS(1,I)=R1(II)
	DIS(2,I)=R1(JJ)
  700 CONTINUE  
	DO 400 N=1,NE
	L=IMAT(N)
C	IF(L.GT.NMAT)L=L-100
      
	CALL MOD(L)
	
	NASH=NCN*(N-1)
	DO 500 K=1,NCN
	MASH=NOP(NASH+K)
	DO 600 I=1,2
	DISE(I,K)=DIS(I,MASH)
	XYE(I,K)=CORD(MASH,I)
  600	CONTINUE
	NOPE(K)=MASH
  500	CONTINUE
	WRITE(6,7)N
    7	FORMAT(1X,'ELEMENT NO#',I3)

	IF(NSTRS.EQ.1)GO TO 300

C    	CALCULATE STRAINS AND STRESSES AT GAUSSIAN POINTS
	WRITE(6,1)
    1	FORMAT(1X,'STRESSES AND SIG1  SIG2  THETA AT GAUSSIAN POINTS')
	WRITE(6,4)
    4	FORMAT(1X,' PT      X           Y            SX                 SY 
     *           TXY           STHE                 SIG1            SIG2         
     *    THETA      STHE')   
      DO 100 IGAUS=1,NGAUS
	DO 100 JGAUS=1,NGAUS
	ICN=NGAUS*IGAUS-NGAUS+JGAUS
	G=XG(IGAUS)
	H=XG(JGAUS)
	CALL SFR(G,H)
	CALL AUX(N)
	CALL STRP(N)
	WRITE(6,2)ICN,XYP(1),XYP(2),(STRS(J),J=1,4),(STRSP(J),J=1,4)
    2	FORMAT(I4,2F9.3,4E13.5,2X,2E12.4,F8.3,E12.4)
  100	CONTINUE
  300	CONTINUE

	IF(NSTRS.EQ.0)GO TO 400

C	CALCULATE STRAINS AND STRESSES AT NODAL POINTS
	WRITE(6,3)
    3	FORMAT(1X, 'STRESSES AND SIG1  SIG2 THETA  NODAL  POINTS ')
	WRITE(6,5)
    5	FORMAT(1X,'NODE      X           Y            SX                SY 
     *          TXY           STHE                 SIG1            SIG2         
     *     THETA       STHE')
        
	XI1=-1.
	ETA1=-1.
	ETA2=-1.
	XI2=1.
	ANSFR=NSFR
	DO 200 NLV=1,NCN,NSFR
	DO 80 I=1,NSFR
	KNEW=NLV+I-1
	GISH=I-1
	GOSH=ANSFR-GISH
	G=(GOSH*XI1+GISH*XI2)/ANSFR
	H=(GOSH*ETA1+GISH*ETA2)/ANSFR
	CALL SFR(G,H)
	CALL AUX(N)
	CALL STRP(N)
	MNEW=NOPE(KNEW)
	WRITE(6,2)MNEW,XYP(1),XYP(2),(STRS(J),J=1,4),(STRSP(J),J=1,4)
   80	CONTINUE
	GISH=-XI1
	GOSH=-ETA1
	XI1=XI2
	ETA1=ETA2
	XI2=GISH
	ETA2=GOSH
  200	CONTINUE
  400	CONTINUE
	RETURN
	END
	

	SUBROUTINE STRP(LNEW)
      COMMON /CONT/ NP,NE,NB,NDF,NLD,NMAT,NCORD,IPRINT,LV,NPP,
     *NCN,NGAUS,ICS,NRE,NRG,NRPRS,NSFR
	COMMON/GEOM/CORD(200,3),IMAT(100),NOP(800),ORT(10,6),
     *D(4,4),E1,E2,C1,C2,G2,
     *NBC(60),NFIX(60),PD(60,2),U(120),XG(6),CG(6)
      COMMON/STIF/
     1P(12),DEL(2,12),COJ(2,2),COJIN(2,2),DET,DI(2,12),DIJ(2,2),DV,
     2NOPE(12),XYE(2,12),DISE(2,12),
     3XYP(3),RP,STRN(4),STRS(4),STRSP(4),
     4ESTIFM(24,24),B(4,24),DVDB(4,24),DVD(4,4)
      

      DO 18 I = 1,2
	DO 18 J = 1,2
	GASH = 0.
	DO 16 K = 1,NCN
	GASH = GASH + DISE(I,K)*DI(J,K)
   16	CONTINUE
	DIJ(I,J) = GASH
   18	CONTINUE
	IF(NPP.NE.2)GO TO 30
	GISH = 0.
	DO 20 K = 1,NCN
	GISH = GISH + DISE(1,K)*P(K)
   20	CONTINUE
	IF(RP.EQ.0.)RP = .000001
	STRN(4) = GISH/RP
   30	CONTINUE
C	CALCULATE STRAIN AT A POINT
	STRN(1)=DIJ(1,1)
	STRN(2)=DIJ(2,2)
	STRN(3)=DIJ(1,2)+DIJ(2,1)
C	CALCULATE STRESSES AT A POINT
	DO 24 I = 1,ICS
	GASH = 0.
	DO 22 J = 1,ICS
	GASH = GASH + D(I,J)*STRN(J)
   22	CONTINUE
	STRS(I) = GASH
   24	CONTINUE
	IF(NPP-1)26,28,32
   26	STRN(4) = 0.
	STRS(4) = C1*STRS(1) + C2*STRS(2)*E1/E2
	GO TO 32
   28	STRS(4)= 0.
	STRN(4)=-(C1*STRS(1)/E1)-(C2*STRS(2)/E2)
   32	CONTINUE
	GASH =(STRS(1)+STRS(2))*.5
	GISH =STRS(1)-GASH
	GESH = STRS(3)
	GOSH = SQRT(GISH*GISH + GESH*GESH)
	STRSP(1)=GASH + GOSH
	STRSP(2)=GASH-GOSH
	STRSP(3)=ATAN(GESH/GISH)*28.647889757
	STRSP(4)=STRS(4)
	RETURN
	END	
	     